/**
 * icode构建的代码中用于请求api，获取数据，并把数据push的state中的公共方法;
 * @param {*} payload 
 * @returns 
 */
export const icodeFetch = async ({
  payload,
  paramStateName,
  dataStateName,
  countStateName,
  loadingStateName,
  isDisabledLoading,
  serviceName,
}) => {
  // 计算请求参数: dataModel 级别小于 state 级别小于 payload.params
  // 处理payload.params参数中的值类型
  const stateParams = Object.assign({}, this.state[paramStateName], payload);
  let requestParam = Object.assign({}, stateParams);

  if (!isDisabledLoading) {
    this.setState({
      [loadingStateName]: true,
    });
  }

  let res = await serviceName(requestParam);
  if (res.result === 'success') {
    let newData = res.data || [];

    // 格式化返回的数据
    newData = parseApiData(newData, { count: { sumType: 'total' } }, '', []);

    this.setState({
      [dataStateName]: newData,
      [countStateName]: res.count,
      [paramStateName]: stateParams,
      [loadingStateName]: false,
    });
  } else {
    this.setState({
      [loadingStateName]: false,
    });
  }

  return res;
};